# enable_gtkdoc: Toggle if gtk-doc files should be rebuilt.
#      0 = no
#      1 = yes
%define enable_gtkdoc 0

# enable_bootstrap: Toggle if bootstrapping package
#      0 = no
#      1 = yes
%define enable_bootstrap 0

# enable_tests: Run test suite in build
#      0 = no
#      1 = yes
%define enable_tests 0

%{?_without_gtkdoc: %{expand: %%define enable_gtkdoc 0}}
%{?_without_bootstrap: %{expand: %%define enable_bootstrap 0}}
%{?_without_tests: %{expand: %%define enable_tests 0}}

%{?_with_gtkdoc: %{expand: %%define enable_gtkdoc 1}}
%{?_with_bootstrap: %{expand: %%define enable_bootstrap 1}}
%{?_with_tests: %{expand: %%define enable_tests 1}}

# required version of various libraries
%define req_glib_version		2.45.8
%define req_pango_version		1.37.3
%define req_atk_version			2.15.1
%define req_cairo_version		1.14.0
%define req_gdk_pixbuf_version		2.30.0

%define pkgname			gtk+
%define api			3
%define api_version		3.0
%define binary_version		3.0.0
%define lib_major		0
%define libname			%mklibname %{pkgname} %{api} %{lib_major}
%define girname			%mklibname gtk-gir %{api_version}
%define develname		%mklibname -d %{pkgname} %{api_version}

%define gail_major 0
%define gail_libname %mklibname gail %{api} %{gail_major}
%define gaildevelname %mklibname -d gail %{api_version}

%define url_ver	%(echo %{version}|cut -d. -f1,2)

Summary:	The GIMP ToolKit (GTK+), a library for creating GUIs
Name:		%{pkgname}%{api_version}
Version:	3.24.2
Release:	%mkrel 1
License:	LGPLv2+
Group:		System/Libraries
Source0:	https://download.gnome.org/sources/%{pkgname}/%{url_ver}/%{pkgname}-%{version}.tar.xz
Source1:    im-cedilla.conf
Patch1:     0001-tooltip-Fix-possibly-briefly-appearing-at-0x0.patch
Patch2:		gtkdialog.c.diff
URL:		http://www.gtk.org
Requires:	common-licenses
Requires:	abattis-cantarell-fonts
Requires:	fontpackages-filesystem
Requires:	gnome-themes-standard
Requires:   adwaita-icon-theme
BuildRequires: gettext-devel
BuildRequires: gtk-doc
BuildRequires: %{_lib}atk1.0-devel
BuildRequires: %{_lib}cairo-devel
BuildRequires: %{_lib}cups2-devel
BuildRequires: %{_lib}fontconfig-devel
BuildRequires: %{_lib}freetype6-devel
BuildRequires: %{_lib}gdk_pixbuf2.0_0
BuildRequires: %{_lib}gdk_pixbuf2.0_0-devel
BuildRequires: %{_lib}girepository-devel
BuildRequires: %{_lib}glib2.0-devel
BuildRequires: %{_lib}glib2.0_0
BuildRequires: %{_lib}pango1.0-devel
BuildRequires: %{_lib}wayland-devel
BuildRequires: %{_lib}x11-devel
BuildRequires: %{_lib}xcomposite-devel
BuildRequires: %{_lib}xcursor-devel
BuildRequires: %{_lib}xdamage-devel
BuildRequires: %{_lib}xext-devel
BuildRequires: %{_lib}xfixes-devel
BuildRequires: %{_lib}xi-devel
BuildRequires: %{_lib}xinerama-devel
BuildRequires: %{_lib}xkbcommon-devel
BuildRequires: %{_lib}xrandr2-devel
BuildRequires: %{_lib}xrender-devel
BuildRequires: libxml2-utils
BuildRequires: gtk+2.0

%if %enable_gtkdoc
BuildRequires:	gtk-doc
BuildRequires:	sgml-tools
BuildRequires:	texinfo
%endif

BuildRequires:	fonts-ttf-dejavu
Requires:	%{libname} = %{version}
Requires: 	gsettings-desktop-schemas
Obsoletes:	gtk-engines3 < 3.0.0
Provides:	%{pkgname}%{api} = %{version}-%{release}
Provides: gtk3

BuildConflicts: colord-devel

%description
The gtk+ package contains the GIMP ToolKit (GTK+), a library for creating
graphical user interfaces for the X Window System.  GTK+ was originally
written for the GIMP (GNU Image Manipulation Program) image processing
program, but is now used by several other programs as well.  

If you are planning on using the GIMP or another program that uses GTK+,
you'll need to have the gtk+ package installed.

%files -f gtk30.lang
%doc README
%{_bindir}/broadwayd
%{_bindir}/gtk-query-immodules-%{api_version}*
%{_bindir}/gtk-query-settings
%{_bindir}/gtk-launch
%{_bindir}/gtk-update-icon-cache
%{_mandir}/man1/gtk-launch.1*
%{_mandir}/man1/broadwayd.1*
%{_mandir}/man1/gtk-query-settings.1*
%{_datadir}/themes
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.Debug.gschema.xml
%{_datadir}/gettext/its/gtkbuilder.*
%dir %{_sysconfdir}/gtk-%{api_version}
%config(noreplace) %{_sysconfdir}/gtk-%{api_version}/im-multipress.conf
%{_sysconfdir}/X11/xinit/xinput.d/im-cedilla.conf
%{_datadir}/themes/Adwaita/gtk-3.0
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.EmojiChooser.gschema.xml
#--------------------------------------------------------------------

%package -n %{libname}
Summary:	%{summary}
Group:		System/Libraries
Provides:	lib%{pkgname}%{api} = %{version}-%{release}
Provides:	lib%{name} = %{version}-%{release}
Provides:   libgtk-3-0
Obsoletes:	%{_lib}gtk+3.0_0 < 3.0.0
Obsoletes:	%{_lib}gtk+-x11-3.0_0 < 3.0.0
Obsoletes:	%{_lib}gtk-engines3 < 3.0.0
Requires:	libglib2.0 >= %{req_glib_version}
Requires:	libpango1.0 >= %{req_pango_version}
Requires:	libatk1.0 >= %{req_atk_version}
Requires:	gtk+3.0 = %{version}-%{release}
Requires:	glib2.0-common
Requires(posttrans):	gtk+3.0

%description -n %{libname}
This package contains the library needed to run programs dynamically
linked with gtk+.

%posttrans -n %{libname}
if [ "$1" = "2" ]; then
        if [ -f %{_sysconfdir}/gtk-%{api_version}/gtk.immodules ]; then
                rm -f %{_sysconfdir}/gtk-%{api_version}/gtk.immodules
        fi
fi
%{_bindir}/gtk-query-immodules-3.0-%{__isa_bits} --update-cache

%files -n %{libname}
%doc README
%ghost %verify (not md5 mtime size) %_libdir/gtk-%{api_version}/3.0.0/immodules.cache
%dir %{_libdir}/gtk-%{api_version}
%dir %{_libdir}/gtk-%{api_version}/modules
%dir %{_libdir}/gtk-%{api_version}/%{binary_version}
%dir %{_libdir}/gtk-%{api_version}/%{binary_version}/immodules
%{_libdir}/gtk-%{api_version}/%{binary_version}/immodules/*.so
%dir %{_libdir}/gtk-%{api_version}/%{binary_version}/printbackends
%{_libdir}/gtk-%{api_version}/%{binary_version}/printbackends/*.so
%{_libdir}/libgtk-3.so.%{lib_major}
%{_libdir}/libgtk-3.so.%{lib_major}.*
%{_libdir}/libgdk-3.so.%{lib_major}
%{_libdir}/libgdk-3.so.%{lib_major}.*

%{_libdir}/girepository-1.0/Gdk-%{api_version}.typelib
%{_libdir}/girepository-1.0/GdkX11-%{api_version}.typelib
%{_libdir}/girepository-1.0/Gtk-%{api_version}.typelib

#--------------------------------------------------------------------

%package -n %{develname}
Summary:	Development files for GTK+ (GIMP ToolKit) applications
Group:		Development/Libraries
Provides:	%{pkgname}%{api}-devel = %{version}-%{release}
Provides:	lib%{pkgname}%{api}-devel = %{version}-%{release}
Provides:	lib%{pkgname}%{api_version}-devel = %{version}-%{release}
Provides:	lib%{pkgname}-x11-%{api_version}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	gtk3-devel = %{version}-%{release}

%description -n %{develname}
The libgtk+-devel package contains the static libraries and header files
needed for developing GTK+ (GIMP ToolKit) applications. The libgtk+-devel
package contains GDK (the General Drawing Kit, which simplifies the interface
for writing GTK+ widgets and using GTK+ widgets in applications), and GTK+
(the widget set).

%files -n %{develname}
%doc docs/*.txt AUTHORS NEWS README*
%doc %{_datadir}/gtk-doc/html/gdk3
%doc %{_datadir}/gtk-doc/html/gtk3
%{_bindir}/gtk3-demo
%{_bindir}/gtk3-demo-application
%{_bindir}/gtk-builder-tool
%{_bindir}/gtk3-icon-browser
%{_bindir}/gtk3-widget-factory
%{_bindir}/gtk-encode-symbolic-svg
%{_datadir}/glib-2.0/schemas/org.gtk.Demo.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.exampleapp.gschema.xml
%{_datadir}/aclocal/*
%{_datadir}/gtk-%{api_version}
%{_includedir}/gtk-%{api_version}
%{_libdir}/libgtk-%{api}.so
%{_libdir}/libgdk-%{api}.so
%{_libdir}/pkgconfig/gdk-*%{api_version}.pc
%{_libdir}/pkgconfig/gtk+-*%{api_version}.pc
%_datadir/gir-1.0/Gdk-%{api_version}.gir
%_datadir/gir-1.0/GdkX11-%{api_version}.gir
%_datadir/gir-1.0/Gtk-%{api_version}.gir
%{_datadir}/applications/gtk3-demo.desktop
%{_datadir}/applications/gtk3-icon-browser.desktop
%{_datadir}/applications/gtk3-widget-factory.desktop
%{_iconsdir}/*/*/*/gtk3-demo*.*
%{_iconsdir}/*/*/*/gtk3-widget-factory*.*
%{_mandir}/man1/gtk3-demo.1*
%{_mandir}/man1/gtk-builder-tool.1*
%{_mandir}/man1/gtk3-demo-application.1*
%{_mandir}/man1/gtk3-icon-browser.1*
%{_mandir}/man1/gtk3-widget-factory.1*
%{_mandir}/man1/gtk-encode-symbolic-svg.1*
%{_mandir}/man1/gtk-query-immodules-3.0.1.bz2

#--------------------------------------------------------------------

%package -n %{gail_libname}
Summary:	GNOME Accessibility Implementation Library
Group:		System/Libraries
Provides:	libgail = %{version}-%{release}
Obsoletes:	%{_lib}gail3.0_0 < 3.0.0

%description -n %{gail_libname}
Gail is the GNOME Accessibility Implementation Library

%files -n %gail_libname
%{_libdir}/libgailutil-%{api}.so.%{gail_major}*

#--------------------------------------------------------------------

%package -n %gaildevelname
Summary:	Static libraries, include files for GAIL
Group:		Development/Libraries
Provides:	libgail-%{api_version}-devel = %{version}-%{release}
Requires:	%{gail_libname} = %{version}

%description -n %gaildevelname
Gail is the GNOME Accessibility Implementation Library

%files -n %gaildevelname
%{_datadir}/gtk-doc/html/gail-libgail-util3
%{_libdir}/libgailutil-%{api}.so
%{_includedir}/gail-%{api_version}
%{_libdir}/pkgconfig/gail-%{api_version}.pc

#--------------------------------------------------------------------

%prep
%setup -qn %{pkgname}-%{version}



%build
NOCONFIGURE=1 ./autogen.sh
(if ! test -x configure; then NOCONFIGURE=1 ./autogen.sh; CONFIGFLAGS=--enable-gtk-doc; fi;
%configure2_5x $CONFIGFLAGS \
        --enable-gtk2-dependency \
        --enable-xkb \
        --enable-xinerama \
        --enable-xrandr \
        --enable-xfixes \
        --enable-xcomposite \
        --enable-xdamage \
        --enable-x11-backend \
	--enable-introspection \
	--enable-broadway-backend \
	--enable-wayland-backend
)

# fight unused direct deps
sed -i -e 's/ -shared / -Wl,-O1,--as-needed\0/g' libtool

%make


%install
rm -rf %buildroot
%makeinstall_std RUN_QUERY_IMMODULES_TEST=false RUN_QUERY_LOADER_TEST=false

touch %buildroot%_libdir/gtk-%{api_version}/%{binary_version}/immodules.cache
mkdir -p %buildroot%{_libdir}/gtk-%{api_version}/modules

(cd %buildroot%{_bindir}
 mv gtk-query-immodules-3.0 gtk-query-immodules-3.0-%{__isa_bits}
)

# Input method frameworks want this
install -D %{SOURCE1} %buildroot%{_sysconfdir}/X11/xinit/xinput.d/im-cedilla.conf
%{find_lang} gtk30 gtk30 gtk30-properties


mkdir -p %{buildroot}%{_datadir}/themes/Adwaita/gtk-3.0
cp -a gtk/theme/Adwaita/gtk{,-dark}.css %{buildroot}%{_datadir}/themes/Adwaita/gtk-3.0

#remove not packaged files
find %{buildroot} -name *.la | xargs rm
rm -f %buildroot%_mandir/man1/gtk-update-icon-cache.1*

%changelog
* Sun Dec 16 2018 adrianomorselli <adrianomorselli> 3.24.2-1uplos2018
- update
